/*
 * File: $HeadURL: https://hdt-java.googlecode.com/svn/trunk/hdt-java/src/org/rdfhdt/hdt/util/LRUCache.java $
 * Revision: $Rev: 191 $
 * Last modified: $Date: 2013-03-03 11:41:43 +0000 (dom, 03 mar 2013) $
 * Last modified by: $Author: mario.arias $
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation;
 * version 3.0 of the License.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 *
 * Contacting the authors:
 *   Mario Arias:               mario.arias@deri.org
 *   Javier D. Fernandez:       jfergar@infor.uva.es
 *   Miguel A. Martinez-Prieto: migumar2@infor.uva.es
 *   Alejandro Andres:          fuzzy.alej@gmail.com
 */

package org.rdfhdt.hdt.util;

import java.util.LinkedHashMap;
import java.util.Map;

/**
 * @author mario.arias 
 *
 */
public class LRUCache<K,V> extends LinkedHashMap<K, V> {
	
	private static final long serialVersionUID = 1L;
	
	int entries=1024;
	
	public LRUCache() {
		this(1024);
	}
	
	public LRUCache(int entries) {
		super(entries+1, .75F, true);
		this.entries = entries;
	}
	
	 // This method is called just after a new entry has been added
	@Override
    public boolean removeEldestEntry(Map.Entry<K,V> eldest) {
        return size() > entries;
    }
}
